;Act as $025
;This is a custom block that drains the air meter.


!Freeram_Drainbar = $7F8828 ;>[1 byte]
;^format ------AD
;D = If set, clear itself and set bit A (so that it stops when a code stops
;writing this), otherwise if already clear, only clear bit A.
;A = The actual flag that determines should the bar drain.

db $42
JMP MarioBelow : JMP MarioAbove : JMP MarioSide
JMP SpriteV : JMP SpriteH : JMP MarioCape : JMP MarioFireball
JMP TopCorner : JMP BodyInside : JMP HeadInside

MarioBelow:
MarioAbove:
MarioSide:
TopCorner:
BodyInside:
HeadInside:
	REP #$20                ;\If mario's block hitbox is not at least a
	LDA $9A                 ;|pixel overlapping the block's hitbox,
	AND #$FFF0              ;|then return.
	SEC                     ;|
	SBC #$000E              ;|
	CMP $94			;|
	BPL ReturnTo8Bit        ;|
	CLC                     ;|
	ADC #$001A              ;|> this means #$0C if starting at #$00
	CMP $94                 ;|
	BMI ReturnTo8Bit        ;|
	SEP #$20                ;/

	LDA !Freeram_Drainbar
	ORA.b #%00000001
	STA !Freeram_Drainbar

SpriteV:
SpriteH:
MarioCape:
MarioFireball:
ReturnTo8Bit:
	SEP #$20
	RTL

print "Drains the air meter."